# Enum Class VulkanImageUsageFlag

java.lang.Object
java.lang.Enum<VulkanImageUsageFlag>
com.io7m.jcoronado.api.VulkanImageUsageFlag

All Implemented Interfaces:
  `VulkanEnumBitmaskType`, `Serializable`, `Comparable<VulkanImageUsageFlag>`, `Constable`

public enum VulkanImageUsageFlag extends Enum<VulkanImageUsageFlag> implements VulkanEnumBitmaskType

See Also:
  - "VkImageUsageFlags"

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `VK_IMAGE_USAGE_COLOR_ATTACHMENT_BIT`
  Can be used as framebuffer color attachment
  `VK_IMAGE_USAGE_DEPTH_STENCIL_ATTACHMENT_BIT`
  Can be used as framebuffer depth/stencil attachment
  `VK_IMAGE_USAGE_INPUT_ATTACHMENT_BIT`
  Can be used as framebuffer input attachment
  `VK_IMAGE_USAGE_SAMPLED_BIT`
  Can be sampled from (SAMPLED_IMAGE and COMBINED_IMAGE_SAMPLER descriptor types)
  `VK_IMAGE_USAGE_STORAGE_BIT`
  Can be used as storage image (STORAGE_IMAGE descriptor type)
  `VK_IMAGE_USAGE_TRANSFER_DST_BIT`
  Can be used as a destination of transfer operations
  `VK_IMAGE_USAGE_TRANSFER_SRC_BIT`
  Can be used as a source of transfer operations
  `VK_IMAGE_USAGE_TRANSIENT_ATTACHMENT_BIT`
  Image data not needed outside of rendering

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `value()`
  `static VulkanImageUsageFlag`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static VulkanImageUsageFlag[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### VK_IMAGE_USAGE_TRANSFER_SRC_BIT

    public static final VulkanImageUsageFlag VK_IMAGE_USAGE_TRANSFER_SRC_BIT
    Can be used as a source of transfer operations

  - ### VK_IMAGE_USAGE_TRANSFER_DST_BIT

    public static final VulkanImageUsageFlag VK_IMAGE_USAGE_TRANSFER_DST_BIT
    Can be used as a destination of transfer operations

  - ### VK_IMAGE_USAGE_SAMPLED_BIT

    public static final VulkanImageUsageFlag VK_IMAGE_USAGE_SAMPLED_BIT
    Can be sampled from (SAMPLED_IMAGE and COMBINED_IMAGE_SAMPLER descriptor types)

  - ### VK_IMAGE_USAGE_STORAGE_BIT

    public static final VulkanImageUsageFlag VK_IMAGE_USAGE_STORAGE_BIT
    Can be used as storage image (STORAGE_IMAGE descriptor type)

  - ### VK_IMAGE_USAGE_COLOR_ATTACHMENT_BIT

    public static final VulkanImageUsageFlag VK_IMAGE_USAGE_COLOR_ATTACHMENT_BIT
    Can be used as framebuffer color attachment

  - ### VK_IMAGE_USAGE_DEPTH_STENCIL_ATTACHMENT_BIT

    public static final VulkanImageUsageFlag VK_IMAGE_USAGE_DEPTH_STENCIL_ATTACHMENT_BIT
    Can be used as framebuffer depth/stencil attachment

  - ### VK_IMAGE_USAGE_TRANSIENT_ATTACHMENT_BIT

    public static final VulkanImageUsageFlag VK_IMAGE_USAGE_TRANSIENT_ATTACHMENT_BIT
    Image data not needed outside of rendering

  - ### VK_IMAGE_USAGE_INPUT_ATTACHMENT_BIT

    public static final VulkanImageUsageFlag VK_IMAGE_USAGE_INPUT_ATTACHMENT_BIT
    Can be used as framebuffer input attachment

- ## Method Details

  - ### values

    public static VulkanImageUsageFlag[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static VulkanImageUsageFlag valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### value

    public int value()
    Specified by:
      `value` in interface `VulkanEnumBitmaskType`
    Returns:
      The integer value of the constant